#import "CTSentenceFormatter.h"

#include "Pawn.h"

@implementation CTSentenceFormatter

- (id) init
{
    self=[super init];
    
    if (self!=nil)
	{
		characterSet_=[[NSCharacterSet characterSetWithCharactersInString:@" ABCDEFGHIJKLMNOPQRSTUVWXYZ.,abcedfghijklmnopqrstuvwxyz"] retain];
	}
    
    return self;
}

- (void) dealloc
{
	[characterSet_ release];
	
	[super dealloc];
}

- (NSString *) stringForObjectValue:(id) inObject
{
    return ((inObject && [inObject isKindOfClass:[NSString class]]) ? inObject : @"");
}

- (BOOL) getObjectValue:(id *) outObject forString:(NSString *) inString errorDescription:(NSString **) outError
{
    *outObject=[[inString copy] autorelease];
	
    return YES;
}

- (BOOL)isPartialStringValid:(NSString *)partialString newEditingString:(NSString **) outString errorDescription:(NSString **) outError
{
    NSUInteger i,tLength;
    unichar tUniChar;
    
    tLength=[partialString length];
    
    if (tLength>(MAX_TEXT_LEN-1))
    {
        *outString=nil;
		
        *outError=@"Error";
		
        return NO;
    }
    
    if (tLength>0)
    {
        for(i=0;i<tLength;i++)
        {
            tUniChar=[partialString characterAtIndex:i];
            
            if ([characterSet_ characterIsMember:tUniChar]==NO)
            {
                *outString=nil;
                
                *outError=@"Error";
                
                return NO;
            }
        }
    }
    
    return YES;
}

@end
