//
//  CircleTextView.h
//  CircleText
//
//  Created by stephane on Wed Jul 11 2001.
//

/*
    07/07/03:
        Support for better localization added by Heiko Wichmann
*/

#import <AppKit/AppKit.h>
#import <ScreenSaver/ScreenSaver.h>
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>

#include "Pawn.h"

@interface CircleTextView : ScreenSaverView
{
    NSOpenGLView *_view;
    
    int mainScreenOnly_;
    
    BOOL isConfiguring_;
    BOOL preview_;
    BOOL mainScreen_;
    
    IBOutlet id configureSheet_;
    
    IBOutlet id IBmainScreen_;
	
    IBOutlet id IBarray_;
	
	IBOutlet id IBadd_;
    IBOutlet id IBremove_;
    
	IBOutlet id IBbox_;
	
	IBOutlet id IBsettingsView_;
	
    IBOutlet id IBradius_;
    IBOutlet id IBscale_;
    IBOutlet id IBrotationSpeed_;
    IBOutlet id IBx_;
    IBOutlet id IBy_;
	
	IBOutlet id IBemptySelectionView_;
	
	IBOutlet id IBmultipleSelectionView_;
	
	// Data
	
	id currentView_;
	
	NSBundle * bundle_;
	
	NSMutableArray * circlesArray_;
	
	NSMutableDictionary * cachedDictionary_;

	circ_def * circleDefinitionsArray_;
	
	int circleDefinitionsCount_;
}

+ (circ_def *) circleDefinitionsFromArray:(NSArray *) inArray count:(int *) outCount;

+ (NSArray *) arrayWithCircleDef:(circ_def *) inCircleDefs count:(int) inCount;


- (IBAction) addSentence:(id) sender;

- (IBAction) removeSentence:(id) sender;

- (void) removeSheetDidEnd:(NSWindow *)sheet returnCode:(NSInteger) returnCode contextInfo:(void *)contextInfo;

- (void) showValuesForRow:(NSInteger) inRowIndex;


- (IBAction) setRadius:(id) sender;
- (IBAction) setScale:(id) sender;

- (IBAction) setX:(id) sender;
- (IBAction) setY:(id) sender;
- (IBAction) setRotationSpeed:(id) sender;

- (IBAction) endDialog:(id) sender;

// Notifications

- (void) tableViewSelectionDidChange:(NSNotification *) inNotification;

@end
